<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_FileCreator extends Controller_Handler
{

    public function before() {
        $this->model = new Model_Teacher_Rating;
        $this->setAccessLevel(self::ACCESS_USER);
        parent::before();
    }
    
    // Таблица баллов (со страницы оценивания) [dev version]
    public function action_GenerateExcelRatingTable()
    {
        // TODO CHECK!!!

            $xls = new PHPExcel();

            // Устанавливаем индекс активного листа
            $xls->setActiveSheetIndex(0);

            // Получаем активный лист
            $sheet = $xls->getActiveSheet();


            // Шапка таблицы: структура УКД (модули и мероприятия)
            $structure = $this->model->GetMapForDiscipline($this->user['TeacherID'], $this->post->offsetGet('disciplineID'));

            $structureHandled = array();
            $maxRate = 0; $i = 0; $module = 0;

            foreach($structure as $row)
            {
                if($row['ModuleID'] != $module)
                {
                    $i++;
                    $module = $row['ModuleID'];
                }
                if(!isset($structureHandled[$i]['SubmodulesCount']))
                {
                    $structureHandled[$i]['SubmodulesCount'] = 0;
                    $structureHandled[$i]['MaxRate'] = 0;
                }
                $j = $structureHandled[$i]['SubmodulesCount'] += 1;
                $structureHandled[$i]['MaxRate'] += (int) $row['MaxRate'];
                $structureHandled[$i]['ModuleTitle'] = $row['ModuleName'];
                $structureHandled[$i]['ModuleType'] = $row['ModuleType'];
                        
                $structureHandled[$i][$j]['SubmoduleID'] = $row['SubmoduleID'];
                $structureHandled[$i][$j]['Title'] = $row['SubModuleName'];

                $structureHandled[$i][$j]['MaxRate'] = (int) $row['MaxRate'];
                $maxRate += $row['MaxRate'];
            }
            $structureHandled['ModulesCount'] = $i;
            $structureHandled['MaxRate'] = (int) $maxRate;

            $sheet->setCellValueByColumnAndRow(
                0, // Столбец. Индексация с 0
                1, // Строка. Индексация с 1
                'Модуль'
            );

            $sheet->setCellValueByColumnAndRow(
                0,
                2,
                'Мероприятие'
            );

            $sheet->setCellValueByColumnAndRow(
                0,
                3,
                'Макс. балл'
            );

            $SubmodulesCount = 0;
            // Модули
            for ($k = 1; $k <=  $structureHandled['ModulesCount']; $k++)
            {
                if ($k == 1) $pointer = 1;

                $sheet->mergeCellsByColumnAndRow($pointer, 1, $pointer + $structureHandled[$k]['SubmodulesCount'] - 1, 1);

                $sheet->setCellValueByColumnAndRow(
                    $pointer,
                    1,
                    $structureHandled[$k]['ModuleTitle']
                );

                $l = 0;
                // Мероприятия
                for ($l = 1; $l <= $structureHandled[$k]['SubmodulesCount']; $l++)
                {
                    $sheet->setCellValueByColumnAndRow(
                        $pointer + $l - 1,
                        2,
                        $structureHandled[$k][$l]['Title']
                    );

                    $sheet->setCellValueByColumnAndRow(
                        $pointer + $l - 1,
                        3,
                        $structureHandled[$k][$l]['MaxRate']
                    );
                    $SubmodulesCount++;
                }

                $pointer = $structureHandled[$k]['SubmodulesCount'] + 1;
            }

            $sheet->setCellValueByColumnAndRow(
                $SubmodulesCount + 1,
                1,
                'Итог'
            );

            $sheet->mergeCellsByColumnAndRow( $SubmodulesCount + 1, 1,  $SubmodulesCount + 1, 3 );

            // Студенты и их баллы
            $students = $this->model->GetStudentsForRating($this->user['TeacherID'], $this->post->offsetGet('disciplineID'));

            $i_s = 0; $curGroup = 0; $ratesum = 0;

            foreach($students as $row) {
                if ($curGroup !== $row['GroupID']) {
                    $curGroup = $row['GroupID'];
                    $i_s++;
                    $sheet->mergeCellsByColumnAndRow( 0, 3 + $i_s,  $SubmodulesCount + 1, 3 + $i_s );
                    $sheet->setCellValueByColumnAndRow(
                        0,
                        3 + $i_s,
                        $row['GroupNum']." группа"
                    );
                }
                // Студенты
                $i_s++;
                $ratesum += $r['Rate'];

                $sheet->setCellValueByColumnAndRow(
                    0,
                    3 + $i_s,
                    $row['Last'].' '.$row['First'].' '.$row['Second']
                );

                // Баллы студента
                $rate = $this->model->getMapForStudent($row['ID'], $this->post->offsetGet('disciplineID'));
                $i_r = 0;
                foreach($rate as $r) {
                    $i_r++;
                    $sheet->setCellValueByColumnAndRow(
                        $i_r,
                        3 + $i_s,
                        $r['Rate']
                    );
                }

                $sheet->setCellValueByColumnAndRow(
                    $SubmodulesCount + 1, // Столбец. Индексация с 0
                    3 + $i_s,
                    $ratesum
                );

            }


            $this->GetHeaders();
             
            // Выводим содержимое файла
            $objWriter = new PHPExcel_Writer_Excel5($xls);
            $objWriter->save('php://output');
    }

    // Ведомость
    public function action_GenerateExcelStatement()
    {
        // TODO CHECK!!! // TODO      
		
        // parameters
        $disciplineID = $this->post->offsetGet('disciplineID');
        $groupID = $this->post->offsetGet('studyGroupID');
  
        // preparation
        $db = $this->model;
        $info = $db->getFinalFormInfo($disciplineID, $groupID);
        $result = $db->getRatesForStudentsGroup($this->user['TeacherID'], $disciplineID, $groupID);
        $rowsCount = count($result); // Получаем количество записей 
        $type = $info[0]['ExamType'];
        
        
        $templateFile = DOCROOT."docs/template $type.xls";
        if (!file_exists($templateFile)) {
            exit("template wasn't found" . PHP_EOL); // TODO
        }
        $objPHPExcel = PHPExcel_IOFactory::load($templateFile);
        $objPHPExcel->setActiveSheetIndex(0);
		        
        // $specName = '';  <------- TODO
   
        // fill header
        $sheet = $objPHPExcel->getActiveSheet();
        $this->prepareSheet($objPHPExcel, $type, $info[0]);
                
        // fill students rows
        $startRow = 13; 
        $finalRow = 52;   
        $rowNumber = $startRow;
        $index = 1;

        foreach($result as $studentInfo){
            $this->addStudent($objPHPExcel, $studentInfo, $rowNumber, $index);
            $rowNumber++;
            $index++;				
        }    
           
        $this->GetHeaders("FinalForm".$disciplineID."_".$groupID);
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save('php://output');
    } 

    public function prepareSheet(&$objPHPExcel, $examType, $data) {
        $sheet = $objPHPExcel->getActiveSheet();
        
        $range = $objPHPExcel->getNamedRange("Discipline")->getRange();
        $sheet->setCellValue($range, $data['SubjectName']);
        $range = $objPHPExcel->getNamedRange("Group")->getRange();
        $sheet->setCellValue($range, $data['GroupNum']);
        $range = $objPHPExcel->getNamedRange("Subdivision")->getRange();
        $sheet->setCellValue($range, $data['FacultyName']);
        $range = $objPHPExcel->getNamedRange("Major")->getRange();  
        $sheet->setCellValue($range, "Специальность: ".$data['SpecName']." ".$data['SpecCode']);
        $range = $objPHPExcel->getNamedRange("Teacher")->getRange();
        $sheet->setCellValue($range, $data['LastName']." ".$data['FirstName']." ".$data['SecondName']);
        $range = $objPHPExcel->getNamedRange("Grade")->getRange();
        $sheet->setCellValue($range, $data['GradeNum']);
        $range = $objPHPExcel->getNamedRange("Semester")->getRange();
        $sheet->setCellValue($range, $data['SemesterNum']);
        $range = $objPHPExcel->getNamedRange("Year")->getRange();
        $sheet->setCellValue($range, $data['Year']);
        $range = $objPHPExcel->getNamedRange("CreationDate")->getRange();
        $sheet->setCellValue($range, date("d.m.y"));
        $range = $objPHPExcel->getNamedRange("Date")->getRange();
        if ($type == 'exam') {
            $controlDate = '__________';
        } else {
            $controlDate = '30.12.2014';
        }
        $sheet->setCellValue("$range", "Дата зачета \n$controlDate");
    }
    
    public function addStudent(&$objPHPExcel, $data, $row, $index) 
    {
            $sheet = $objPHPExcel->getActiveSheet();
        
            $indPosition = 'A'; // Номер 
            $namePosition = 'B';  // ФИО 
            $totalRatePosition = 'G';  // Итоговый рейтинг 
            $semesterRatePosition  = 'H';   // Сумма баллов
            $bonusRatePosition = 'I'; // Бонусные баллы
        
            $sheet  ->getStyle("A".$row.":S".$row)
                    ->getBorders()->getAllBorders()
                    ->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);
            $sheet->mergeCells("B".$row.":F".$row);
			
            $lastName = $data['Last'];
            $firstName = $data['First'];
            $secondName = $data['Second'];
            $rate = (int)$data['intermediate'];
            $bonus = (int)$data['bonus'];
            $fullName = $lastName." ".$firstName." ".$secondName;
            $totalRate = $rate + $bonus;
			
            if($totalRate < 60) {
                    $tempRate = " ";
                    $tempStr = "не зачтено";
            } else {
                    $tempStr = "зачтено";
                    $tempRate = $totalRate;
            }
			
            $sheet  ->setCellValue($indPosition.$row, $index)
                    ->setCellValue($namePosition.$row, $fullName)
                    ->setCellValue($totalRatePosition.$row, $tempRate)
                    ->setCellValue($semesterRatePosition.$row, $rate)
                    ->setCellValue($bonusRatePosition.$row, $bonus)
                    ->setCellValue("J".$row, $tempStr);
        
    }
    
        // Ведомость
    public function action_GenerateExcelFullStatementByStudyGroupID()
    {

        $type = 'credit';
        $templateFile = DOCROOT."docs/template $type.xls";
        if (!file_exists($templateFile)) {
            exit("template wasn't found" . PHP_EOL); // TODO
        }

        $objPHPExcel = PHPExcel_IOFactory::load($templateFile);
        $objPHPExcel->setActiveSheetIndex(0);
        
        $objPHPExcel_1 = PHPExcel_IOFactory::load($DOCROOT."docs/template exam.xls");
        $sheet = $objPHPExcel_1->setActiveSheetIndex(0);
        $objPHPExcel->addExternalSheet($sheet);

        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
        //$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
        //$objWriter->save('1.xls');

        $this->GetHeaders("FinalForm".$disciplineID."_".$groupID);

        $objWriter->save('php://output');

    }
    
    
    // Выводим HTTP-заголовки
    public function GetHeaders($filename = 'excel')
    {
        $this->response->headers("Last-Modified", gmdate("D,d M YH:i:s") . " GMT" );
        $this->response->headers( "Cache-Control", " no-cache, must-revalidate" );
        $this->response->headers("Pragma", " no-cache" );
        $this->response->headers("Content-type", " application/vnd.ms-excel" );
        $this->response->headers("Content-Disposition", "attachment; filename=".$filename.".xls" );
    }

}